Index: binaries/data/mods/public/maps/random/rmgen/library.js
===================================================================
--- binaries/data/mods/public/maps/random/rmgen/library.js	(revision 17723)
+++ binaries/data/mods/public/maps/random/rmgen/library.js	(working copy)
@@ -1,22 +1,38 @@
-
-/////////////////////////////////////////////////////////////////////////////////////////////
-//	Constant definitions
-/////////////////////////////////////////////////////////////////////////////////////////////
-
+/**
+ * Constant definitions
+ */
 const PI = Math.PI;
-const TWO_PI = 2 * Math.PI;
+const TWO_PI = 2 * Math.PI; // mathematically known as 'tau'
 const TERRAIN_SEPARATOR = "|";
-const SEA_LEVEL = 20.0;
+const SEA_LEVEL = 160.0;
 const CELL_SIZE = 4;
 const HEIGHT_UNITS_PER_METRE = 92;
 const MIN_MAP_SIZE = 128;
 const MAX_MAP_SIZE = 512;
 const FALLBACK_CIV = "athen";
 
-/////////////////////////////////////////////////////////////////////////////////////////////
-//	Utility functions
-/////////////////////////////////////////////////////////////////////////////////////////////
+/**
+ * Constants needed for heightmap_manipulation.js
+ */
+const MAX_HEIGHT_RANGE = 0xFFFF / HEIGHT_UNITS_PER_METRE // Engine limit, Roughly 700 meters
+const MIN_HEIGHT = - SEA_LEVEL;
+const MAX_HEIGHT = MAX_HEIGHT_RANGE - SEA_LEVEL;
+/**
+ * Entity template structure keys that might change, for easier mod support
+ */
+const CIV_PLACEHOLDER_STRING = "{civ}";
+const START_ENTITY_KEYS = ["StartEntities"];
+const START_ENTITY_TEMPLATE_KEYS = ["Template"];
+const BUILDER_TEMPLATEPATH_KEYS = ["Builder", "Entities", "_string"];
+const PRODUCTION_TEMPLATEPATH_KEYS = ["ProductionQueue", "Entities", "_string"];
+const WALLSET_KEYS = ["WallSet"];
+const BUILDING_KEYS = ["Obstruction", "Static"];
 
+
+/**
+ * Utility functions
+ */
+
 function fractionToTiles(f)
 {
 	return getMapSize() * f;
@@ -103,7 +119,7 @@
 	if (numArgs != 1)
 	{
 		var ret = new Array(numArgs);
-		for (var i=0; i < numArgs; i++)
+		for (var i=0; i < numArgs; ++i)
 		{
 			ret[i] = x[i];
 		}
@@ -125,14 +141,16 @@
 	return ar[randInt(ar.length)];
 }
 
-// "Inside-out" implementation of Fisher-Yates shuffle
+/**
+ * "Inside-out" implementation of Fisher-Yates shuffle
+ */
 function shuffleArray(source)
 {
 	if (!source.length)
 		return [];
 
 	var result = [source[0]];
-	for (var i = 1; i < source.length; i++)
+	for (var i = 1; i < source.length; ++i)
 	{
 		var j = randInt(0, i);
 		result[i] = result[j];
@@ -172,12 +190,12 @@
 		var area = g_Map.createArea(centeredPlacer, painter, constraint);
 		if (area !== undefined)
 		{
-			good++;
+			++good;
 			result.push(area);
 		}
 		else
 		{
-			bad++;
+			++bad;
 		}
 	}
 	return result;
@@ -208,12 +226,12 @@
 		var area = g_Map.createArea(centeredPlacer, painter, constraint);
 		if (area !== undefined)
 		{
-			good++;
+			++good;
 			result.push(area);
 		}
 		else
 		{
-			bad++;
+			++bad;
 		}
 	}
 	return result;
@@ -248,11 +266,11 @@
 		var result = createObjectGroup(placer, player, constraint);
 		if (result !== undefined)
 		{
-			good++;
+			++good;
 		}
 		else
 		{
-			bad++;
+			++bad;
 		}
 	}
 	return good;
@@ -282,11 +300,11 @@
 		var result = createObjectGroup(placer, player, constraint);
 		if (result !== undefined)
 		{
-			good++;
+			++good;
 		}
 		else
 		{
-			bad++;
+			++bad;
 		}
 	}
 	return good;
@@ -349,9 +367,9 @@
 	return (g_MapSettings.CircularMap ? true : false);
 }
 
-/////////////////////////////////////////////////////////////////////////////////////////////
-//	Access global map variable
-/////////////////////////////////////////////////////////////////////////////////////////////
+/**
+ * Access global map variable
+ */
 
 function createTileClass()
 {
@@ -394,15 +412,137 @@
 	return g_MapSettings.PlayerData.length - 1;
 }
 
+/**
+ * Takes nothing, returns an array of strings representing all available civilizations
+ */
+function getCivList()
+{
+	var raw_civData = RMS.GetCivData();
+	var civList = [];
+	for (var i = 0; i < raw_civData.length; ++i)
+		civList.push(JSON.parse(raw_civData[i]).Code);
+	
+	return civList;
+}
+
+/**
+ * Takes nothing, returns an associative array with civ strings as keys containing all unpacked civ data (Templates need to be unpacked with RMS.GetTemplate() if needed)
+ */
+function getFullCivData()
+{
+	var rawCivData = RMS.GetCivData();
+	var unpackedCivData = {};
+	for (var i = 0; i < rawCivData.length; ++i)
+	{
+		var singleCivData = JSON.parse(rawCivData[i]);
+		unpackedCivData[singleCivData.Code] = singleCivData;
+	}
+	
+	return unpackedCivData;
+}
+
+/**
+ * Takes a player number (0-7, so Gaia excluded). Returns this players civ string
+ * ToDo: If the player number is to high an error will occur (and the fallback won't be reached)!
+ */
 function getCivCode(player)
 {
 	if (g_MapSettings.PlayerData[player+1].Civ)
 		return g_MapSettings.PlayerData[player+1].Civ;
 
-	warn("undefined civ specified for player " + (player + 1) + ", falling back to '" + FALLBACK_CIV + "'");
+	warn("Undefined civ specified for player " + (player + 1) + ", falling back to '" + FALLBACK_CIV + "'");
 	return FALLBACK_CIV;
 }
 
+/**
+ * Takes an entity path and a key list to get the templates value
+ */
+function getTemplateValue(entPath, key_list)
+{
+	var subdata = RMS.GetTemplate(entPath);
+	for (var i = 0; i < key_list.length; ++i)
+	{
+		if (!subdata[key_list[i]])
+		{
+			return false
+		}
+		subdata = subdata[key_list[i]];
+	}
+	return subdata;
+}
+
+/**
+ * Returns a list of all templates paths available to the given civ
+ */
+function getTempatePathList(civ)
+{
+	var templatePaths = getFullCivData();
+	if (!templatePaths[civ])
+	{
+		warn("getTempatePathList: Unknown civ '" + civ + "' not in " + Object.keys(templatePaths));
+		return false;
+	}
+	templatePaths = templatePaths[civ];
+	
+	if (!templatePaths[START_ENTITY_KEYS])
+	{
+		warn("getTempatePathList: Civ has no starting entities as defined in START_ENTITY_KEYS (" + START_ENTITY_KEYS + "): " + Object.keys(templatePaths));
+		return false;
+	}
+	templatePaths = templatePaths[START_ENTITY_KEYS];
+	
+	for (var i = 0; i < templatePaths.length; ++i)
+	{
+		if (!templatePaths[i][START_ENTITY_TEMPLATE_KEYS])
+		{
+			warn("getTempatePathList: Starting entity list item has no template as defined in START_ENTITY_TEMPLATE_KEYS (" + START_ENTITY_TEMPLATE_KEYS + "): " + Object.keys(templatePaths));
+			return false;
+		}
+		templatePaths[i] = templatePaths[i][START_ENTITY_TEMPLATE_KEYS];
+	}
+	var foundNew = 1;
+	while (foundNew > 0)
+	{
+		foundNew = 0;
+		var methods = [BUILDER_TEMPLATEPATH_KEYS, PRODUCTION_TEMPLATEPATH_KEYS];
+		for (var m = 0; m < methods.length; ++m)
+		{
+			for (var t = 0; t < templatePaths.length; ++t)
+			{
+				var pathsToCheck = getTemplateValue(templatePaths[t], methods[m]);
+				if (typeof(pathsToCheck) === typeof(""))
+				{
+					pathsToCheck = pathsToCheck.split(/\s+/);
+					for (var c = 0; c < pathsToCheck.length; ++c)
+					{
+						var actualPath = pathsToCheck[c].replace(CIV_PLACEHOLDER_STRING, civ);
+						if (templatePaths.indexOf(actualPath) == -1 && RMS.TemplateExists(actualPath))
+						{
+							templatePaths.push(actualPath);
+							++foundNew;
+						}
+					}
+				}
+			}
+		}
+	}
+	return templatePaths;
+}
+
+/**
+ * Takes a list of entity path strings and returns a list with only those remaining that have the specified keys
+ */
+function filterByKeys(entPaths, keys)
+{
+	let filteredEntPaths = [];
+	for (let i = 0; i < entPaths.length; ++i)
+	{
+		if (getTemplateValue(entPaths[i], keys))
+			filteredEntPaths.push(entPaths[i]);
+	}
+	return filteredEntPaths;
+}
+
 function areAllies(player1, player2)
 {
 	if ((g_MapSettings.PlayerData[player1+1].Team === undefined) || (g_MapSettings.PlayerData[player2+1].Team === undefined) || (g_MapSettings.PlayerData[player2+1].Team == -1) || (g_MapSettings.PlayerData[player1+1].Team == -1))
@@ -434,19 +574,17 @@
 
 	var result = new Array(0);
 	var team = new Array(5);
-	for (var q = 0; q < 5; q++)
+	for (var q = 0; q < 5; ++q)
 	{
 		team[q] = new Array(1);
 	}
 
-	for (var i = -1; i < 4; i++)
+	for (var i = -1; i < 4; ++i)
 	{
-		for (var j = 0; j < source.length; j++)
+		for (var j = 0; j < source.length; ++j)
 		{
 			if (getPlayerTeam(j) == i)
-			{
 				team[i+1].unshift(j+1);
-			}
 		}
 		team[i+1].pop();
 		result=result.concat(shuffleArray(team[i+1]))
@@ -461,7 +599,7 @@
 
 	var prime = new Array(source.length);
 
-	for (var i = 0; i < round(source.length/2); i++)
+	for (var i = 0; i < round(source.length/2); ++i)
 	{
 		prime[2*i]=source[i];
 		prime[2*i+1]=source[source.length-1-i];
@@ -492,70 +630,76 @@
 	g_Map.setHeight(x, z, height);
 }
 
-/////////////////////////////////////////////////////////////////////////////////////////////
-//	Utility functions for classes
-/////////////////////////////////////////////////////////////////////////////////////////////
 
+/**
+ *	Utility functions for classes
+ */
 
-// Add point to given class by id
+/**
+ * Add point to given class by id
+ */
 function addToClass(x, z, id)
 {
 	var tileClass = getTileClass(id);
 	
 	if (tileClass !== null)
-	{
 		tileClass.add(x, z);
-	}
 }
 
-// Remove point from the given class by id
+/**
+ * Remove point from the given class by id
+ */
 function removeFromClass(x, z, id)
 {
 	var tileClass = getTileClass(id);
 	
 	if (tileClass !== null)
-	{
 		tileClass.remove(x, z);
-	}
 }
 
-// Create a painter for the given class
+/**
+ * Create a painter for the given class
+ */
 function paintClass(id)
 {
 	return new TileClassPainter(getTileClass(id));
 }
 
-// Create a painter for the given class
+/**
+ * Create a painter for the given class
+ */
 function unPaintClass(id)
 {
 	return new TileClassUnPainter(getTileClass(id));
 }
 
-// Create an avoid constraint for the given classes by the given distances
+/**
+ * Create an avoid constraint for the given classes by the given distances
+ */
 function avoidClasses(/*class1, dist1, class2, dist2, etc*/)
 {
 	var ar = new Array(arguments.length/2);
-	for (var i = 0; i < arguments.length/2; i++)
+	for (var i = 0; i < arguments.length/2; ++i)
 	{
 		ar[i] = new AvoidTileClassConstraint(arguments[2*i], arguments[2*i+1]);
 	}
 	
 	// Return single constraint
 	if (ar.length == 1)
-	{
 		return ar[0];
-	}
 	else
 	{
 		return new AndConstraint(ar);
 	}
 }
 
-// Create a stay constraint for the given classes by the given distances
+/**
+ * Create a stay constraint for the given classes by the given distances
+ */
 function stayClasses(/*class1, dist1, class2, dist2, etc*/)
 {
 	var ar = new Array(arguments.length/2);
-	for (var i = 0; i < arguments.length/2; i++)
+	for (var i = 0; i < arguments.length/2; ++i)
 	{
 		ar[i] = new StayInTileClassConstraint(arguments[2*i], arguments[2*i+1]);
 	}
@@ -571,11 +715,13 @@
 	}
 }
 
-// Create a border constraint for the given classes by the given distances
+/**
+ * Create a border constraint for the given classes by the given distances
+ */
 function borderClasses(/*class1, idist1, odist1, class2, idist2, odist2, etc*/)
 {
 	var ar = new Array(arguments.length/3);
-	for (var i = 0; i < arguments.length/3; i++)
+	for (var i = 0; i < arguments.length/3; ++i)
 	{
 		ar[i] = new BorderTileClassConstraint(arguments[3*i], arguments[3*i+1], arguments[3*i+2]);
 	}
@@ -591,7 +737,9 @@
 	}
 }
 
-// Checks if the given tile is in class "id"
+/**
+ * Checks if the given tile is in class "id"
+ */
 function checkIfInClass(x, z, id)
 {
 	var tileClass = getTileClass(id);
@@ -612,20 +760,25 @@
 	}
 }
 
-
-// Returns the distance between 2 points
+/**
+ * Returns the distance between 2 points
+ */
 function getDistance(x1, z1, x2, z2)
 {
 	return Math.pow(Math.pow(x1 - x2, 2) + Math.pow(z1 - z2, 2), 1/2);
 }
 
-// Returns the angle of the vector between point 1 and point 2.  The angle is anticlockwise from the positive x axis.
+/**
+ * Returns the angle of the vector between point 1 and point 2.  The angle is anticlockwise from the positive x axis.
+ */
 function getAngle(x1, z1, x2, z2)
 {
 	return Math.atan2(z2 - z1, x2 - x1);
 }
 
-// Returns the gradient of the line between point 1 and 2 in the form dz/dx
+/**
+ * Returns the gradient of the line between point 1 and 2 in the form dz/dx
+ */
 function getGradient(x1, z1, x2, z2)
 {
 	if (x1 == x2 && z1 == z2)
@@ -642,4 +795,3 @@
 {
 	return g_Map.getTexture(x, y);
 }
-
Index: binaries/data/mods/public/maps/random/rmgen/misc.js
===================================================================
--- binaries/data/mods/public/maps/random/rmgen/misc.js	(revision 17723)
+++ binaries/data/mods/public/maps/random/rmgen/misc.js	(working copy)
@@ -1,28 +1,26 @@
-/////////////////////////////////////////////////////////////////////////////////////////
-//	passageMaker
-//
-//	Function for creating shallow water between two given points by changing the heiight of all tiles in
-//	the path with height less than or equal to "maxheight" to "height"
-//
-//	x1,z1: 	Starting point of path
-//	x2,z2: 	Ending point of path
-//	width: 	Width of the shallow
-//	maxheight:		Maximum height that it changes
-//	height:		Height of the shallow
-//	smooth:		smooth elevation in borders
-//	tileclass:		(Optianal) - Adds those tiles to the class given
-//	terrain:		(Optional) - Changes the texture of the elevated land
-//
-/////////////////////////////////////////////////////////////////////////////////////////
-
+/**
+ *	passageMaker
+ *
+ *	Function for creating shallow water between two given points by changing the heiight of all tiles in
+ *	the path with height less than or equal to "maxheight" to "height"
+ *
+ *	x1,z1: 	Starting point of path
+ *	x2,z2: 	Ending point of path
+ *	width: 	Width of the shallow
+ *	maxheight:		Maximum height that it changes
+ *	height:		Height of the shallow
+ *	smooth:		smooth elevation in borders
+ *	tileclass:		(Optianal) - Adds those tiles to the class given
+ *	terrain:		(Optional) - Changes the texture of the elevated land
+ */
 function passageMaker(x1, z1, x2, z2, width, maxheight, height, smooth, tileclass, terrain, riverheight)
 {
 	var tchm = TILE_CENTERED_HEIGHT_MAP;
 	TILE_CENTERED_HEIGHT_MAP = true;
 	var mapSize = g_Map.size;
-	for (var ix = 0; ix < mapSize; ix++)
+	for (var ix = 0; ix < mapSize; ++ix)
 	{
-		for (var iz = 0; iz < mapSize; iz++)
+		for (var iz = 0; iz < mapSize; ++iz)
 		{
 			var a = z1-z2;
 			var b = x2-x1;
@@ -73,18 +71,16 @@
 	TILE_CENTERED_HEIGHT_MAP = tchm;
 }
 
-//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-//rndRiver is a fuction that creates random values useful for making a jagged river.
-//
-//it works the same as sin or cos function. the only difference is that it's period is 1 instead of 2*pi
-//it needs the "seed" parameter to use it to make random curves that don't get broken.
-//seed must be created using randFloat(). or else it won't work
-//
-//	f:	Input: Same as angle in a sine function
-//	seed:	Random Seed: Best to implement is to use randFloat()
-//
-//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-
+/**
+ *rndRiver is a fuction that creates random values useful for making a jagged river.
+ *
+ *it works the same as sin or cos function. the only difference is that it's period is 1 instead of 2*pi
+ *it needs the "seed" parameter to use it to make random curves that don't get broken.
+ *seed must be created using randFloat(). or else it won't work
+ *
+ *	f:	Input: Same as angle in a sine function
+ *	seed:	Random Seed: Best to implement is to use randFloat()
+ */
 function rndRiver(f, seed)
 {
 	var rndRq = seed;
@@ -92,7 +88,7 @@
 	var rndRe = 0;
 	var rndRr = f-floor(f);
 	var rndRa = 0;
-	for (var rndRx=0; rndRx<=floor(f); rndRx++)
+	for (var rndRx=0; rndRx<=floor(f); ++rndRx)
 	{
 		rndRw = 10*(rndRw-floor(rndRw));
 	}
@@ -129,16 +125,15 @@
 }
 
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// createStartingPlayerEntities
-//
-//	Creates the starting player entities
-//	fx&fz: position of player base
-//	playerid: id of player
-//	civEntities: use getStartingEntities(id-1) fo this one
-//	BUILDING_ANGlE: angle of main base building
-//
-///////////////////////////////////////////////////////////////////////////////////////////
+/**
+ * createStartingPlayerEntities
+ *
+ *	Creates the starting player entities
+ *	fx&fz: position of player base
+ *	playerid: id of player
+ *	civEntities: use getStartingEntities(id-1) fo this one
+ *	BUILDING_ANGlE: angle of main base building
+ */
 function createStartingPlayerEntities(fx, fz, playerid, civEntities, BUILDING_ANGlE)
 {
 	var uDist = 6;
@@ -148,7 +143,7 @@
 	{
 		var uAngle = BUILDING_ANGlE - PI * (2-j) / 2;
 		var count = (civEntities[j].Count !== undefined ? civEntities[j].Count : 1);
-		for (var numberofentities = 0; numberofentities < count; numberofentities++)
+		for (var numberofentities = 0; numberofentities < count; ++numberofentities)
 		{
 			var ux = fx + uDist * cos(uAngle) + numberofentities * uSpace * cos(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * cos(uAngle + PI/2));
 			var uz = fz + uDist * sin(uAngle) + numberofentities * uSpace * sin(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * sin(uAngle + PI/2));
@@ -157,17 +152,16 @@
 	}
 }
 
-//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-// placeCivDefaultEntities
-//
-//	Creates the default starting player entities depending on the players civ
-//	fx&fy: position of player base
-//	playerid: id of player
-//	angle: angle of main base building, optional, default is BUILDING_ANGlE
-//	kwargs: Takes some optional keyword arguments to tweek things
-//		'iberWall': may be false, 'walls' (default) or 'towers'. Determines the defensive structures Iberians get as civ bonus
-//
-//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+/**
+ * placeCivDefaultEntities
+ *
+ *	Creates the default starting player entities depending on the players civ
+ *	fx&fy: position of player base
+ *	playerid: id of player
+ *	angle: angle of main base building, optional, default is BUILDING_ANGlE
+ *	kwargs: Optional. Takes an associative array with keyword arguments to tweak things:
+ *		Known keys: 'iberWall': may be false, 'walls' (default) or 'towers'. Determines the defensive structures Iberians get as civ bonus
+ */
 function placeCivDefaultEntities(fx, fz, playerid, angle, kwargs)
 {
 	// Unpack kwargs
@@ -187,7 +181,7 @@
 	{
 		var uAngle = angle - PI * (2-j) / 2;
 		var count = (civEntities[j].Count !== undefined ? civEntities[j].Count : 1);
-		for (var numberofentities = 0; numberofentities < count; numberofentities++)
+		for (var numberofentities = 0; numberofentities < count; ++numberofentities)
 		{
 			var ux = fx + uDist * cos(uAngle) + numberofentities * uSpace * cos(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * cos(uAngle + PI/2));
 			var uz = fz + uDist * sin(uAngle) + numberofentities * uSpace * sin(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * sin(uAngle + PI/2));
@@ -205,25 +199,24 @@
 }
 
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// paintTerrainBasedOnHeight
-//
-//	paints the tiles which have a height between minheight and maxheight with the given terrain
-//	minheight: minimum height of the tile
-//	maxheight: maximum height of the tile
-//	mode: accepts 4 values. 0 means the it will select tiles with height more than minheight and less than maxheight.
-//  1 means it selects tiles with height more than or equal to minheight and less than max height. 2 means more than
-//  minheight and less than or equal to maxheight. 3 means more than or equal to minheight and less than or equal to maxheight
-//	terrain: intended terrain texture
-//
-///////////////////////////////////////////////////////////////////////////////////////////
+/**
+ * paintTerrainBasedOnHeight
+ *
+ *	paints the tiles which have a height between minheight and maxheight with the given terrain
+ *	minheight: minimum height of the tile
+ *	maxheight: maximum height of the tile
+ *	mode: accepts 4 values. 0 means the it will select tiles with height more than minheight and less than maxheight.
+ *  1 means it selects tiles with height more than or equal to minheight and less than max height. 2 means more than
+ *  minheight and less than or equal to maxheight. 3 means more than or equal to minheight and less than or equal to maxheight
+ *	terrain: intended terrain texture
+ */
 
 function paintTerrainBasedOnHeight(minheight, maxheight, mode, terrain)
 {
 	var mSize = g_Map.size;
-	for (var qx = 0; qx < mSize; qx++)
+	for (var qx = 0; qx < mSize; ++qx)
 	{
-		for (var qz = 0; qz < mSize; qz++)
+		for (var qz = 0; qz < mSize; ++qz)
 		{
 			if (mode == 0)
 			{
@@ -257,25 +250,23 @@
 	}
 }
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// paintTileClassBasedOnHeight and unPaintTileClassBasedOnHeight
-//
-//	paints or unpaints the tiles which have a height between minheight and maxheight with the given tile class
-//	minheight: minimum height of the tile
-//	maxheight: maximum height of the tile
-//	mode: accepts 4 values. 0 means the it will select tiles with height more than minheight and less than maxheight.
-//  1 means it selects tiles with height more than or equal to minheight and less than max height. 2 means more than
-//  minheight and less than or equal to maxheight. 3 means more than or equal to minheight and less than or equal to maxheight
-//	tileclass: intended tile class
-//
-///////////////////////////////////////////////////////////////////////////////////////////
-
+/**
+ * paintTileClassBasedOnHeight and unPaintTileClassBasedOnHeight
+ *
+ *	paints or unpaints the tiles which have a height between minheight and maxheight with the given tile class
+ *	minheight: minimum height of the tile
+ *	maxheight: maximum height of the tile
+ *	mode: accepts 4 values. 0 means the it will select tiles with height more than minheight and less than maxheight.
+ *  1 means it selects tiles with height more than or equal to minheight and less than max height. 2 means more than
+ *  minheight and less than or equal to maxheight. 3 means more than or equal to minheight and less than or equal to maxheight
+ *	tileclass: intended tile class
+ */
 function paintTileClassBasedOnHeight(minheight, maxheight, mode, tileclass)
 {
 	var mSize = g_Map.size;
-	for (var qx = 0; qx < mSize; qx++)
+	for (var qx = 0; qx < mSize; ++qx)
 	{
-		for (var qz = 0; qz < mSize; qz++)
+		for (var qz = 0; qz < mSize; ++qz)
 		{
 			if (mode == 0)
 			{
@@ -313,9 +304,9 @@
 function unPaintTileClassBasedOnHeight(minheight, maxheight, mode, tileclass)
 {
 	var mSize = g_Map.size;
-	for (var qx = 0; qx < mSize; qx++)
+	for (var qx = 0; qx < mSize; ++qx)
 	{
-		for (var qz = 0; qz < mSize; qz++)
+		for (var qz = 0; qz < mSize; ++qz)
 		{
 			if (mode == 0)
 			{
@@ -349,19 +340,17 @@
 	}
 }
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// getTIPIADBON
-//
-//	"get The Intended Point In A Direction Based On Height"
-//	gets the N'th point with a specific height in a line and returns it as a [x, y] array
-//	startPoint: [x, y] array defining the start point
-//	endPoint: [x, y] array defining the ending point
-//	heightRange: [min, max] array defining the range which the height of the intended point can be. includes both "min" and "max"
-//  step: how much tile units per turn should the search go. more value means faster but less accurate 
-//  n: how many points to skip before ending the search. skips """n-1 points""".
-//
-///////////////////////////////////////////////////////////////////////////////////////////
-
+/**
+ * getTIPIADBON
+ *
+ *	"get The Intended Point In A Direction Based On Height"
+ *	gets the N'th point with a specific height in a line and returns it as a [x, y] array
+ *	startPoint: [x, y] array defining the start point
+ *	endPoint: [x, y] array defining the ending point
+ *	heightRange: [min, max] array defining the range which the height of the intended point can be. includes both "min" and "max"
+ *  step: how much tile units per turn should the search go. more value means faster but less accurate 
+ *  n: how many points to skip before ending the search. skips """n-1 points""".
+ */
 function getTIPIADBON(startPoint, endPoint, heightRange, step, n)
 {
 	var stepX = step*(endPoint[0]-startPoint[0])/(sqrt((endPoint[0]-startPoint[0])*(endPoint[0]-startPoint[0]) + step*(endPoint[1]-startPoint[1])*(endPoint[1]-startPoint[1])));
@@ -394,16 +383,14 @@
 	return undefined;
 }
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// doIntersect
-//
-//	determines if two lines with the width "width" intersect or collide with each other
-//	x1, y1, x2, y2: determine the position of the first line
-//	x3, y3, x4, y4: determine the position of the second line
-//	width: determines the width of the lines
-//
-///////////////////////////////////////////////////////////////////////////////////////////
-
+/**
+ * doIntersect
+ *
+ *	determines if two lines with the width "width" intersect or collide with each other
+ *	x1, y1, x2, y2: determine the position of the first line
+ *	x3, y3, x4, y4: determine the position of the second line
+ *	width: determines the width of the lines
+ */
 function checkIfIntersect (x1, y1, x2, y2, x3, y3, x4, y4, width)
 {
 	if (x1 == x2)
@@ -445,15 +432,13 @@
 	return false;
 }
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// distanceOfPointFromLine
-//
-//	returns the distance of a point from a line
-//	x1, y1, x2, y2: determine the position of the line
-//	x3, y3: determine the position of the point
-//
-///////////////////////////////////////////////////////////////////////////////////////////
-
+/**
+ * distanceOfPointFromLine
+ *
+ *	returns the distance of a point from a line
+ *	x1, y1, x2, y2: determine the position of the line
+ *	x3, y3: determine the position of the point
+ */
 function distanceOfPointFromLine (x1, y1, x2, y2, x3, y3)
 {
 	if (x1 == x2)
@@ -473,20 +458,18 @@
 	}
 }
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// createRamp
-//
-//	creates a ramp from point (x1, y1) to (x2, y2).
-//	x1, y1, x2, y2: determine the position of the start and end of the ramp
-//	minHeight, maxHeight: determine the height levels of the start and end point
-//	width: determines the width of the ramp
-//	smoothLevel: determines the smooth level around the edges of the ramp
-//	mainTerrain: (Optional) determines the terrain texture for the ramp
-//	edgeTerrain: (Optional) determines the terrain texture for the edges
-//	tileclass: (Optional) adds the ramp to this tile class
-//
-///////////////////////////////////////////////////////////////////////////////////////////
-
+/**
+ * createRamp
+ *
+ *	creates a ramp from point (x1, y1) to (x2, y2).
+ *	x1, y1, x2, y2: determine the position of the start and end of the ramp
+ *	minHeight, maxHeight: determine the height levels of the start and end point
+ *	width: determines the width of the ramp
+ *	smoothLevel: determines the smooth level around the edges of the ramp
+ *	mainTerrain: (Optional) determines the terrain texture for the ramp
+ *	edgeTerrain: (Optional) determines the terrain texture for the edges
+ *	tileclass: (Optional) adds the ramp to this tile class
+ */
 function createRamp (x1, y1, x2, y2, minHeight, maxHeight, width, smoothLevel, mainTerrain, edgeTerrain, tileclass)
 {
 	var halfWidth = width / 2;
@@ -540,12 +523,12 @@
 	}
 }
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// createMountain
-//
-//	creates a mountain using a tecnique very similar to chain placer.
-//
-///////////////////////////////////////////////////////////////////////////////////////////
+/**
+ * createMountain
+ *
+ *	creates a mountain using a tecnique very similar to chain placer.
+ *
+ */
 
 function createMountain(maxHeight, minRadius, maxRadius, numCircles, constraint, x, z, terrain, tileclass, fcc, q)
 {
@@ -617,7 +600,7 @@
 		
 		for (var ix = sx; ix <= lx; ++ix)
 		{
-			for (var iz = sz; iz <= lz; ++ iz)
+			for (var iz = sz; iz <= lz; ++iz)
 			{
 				dx = ix - cx;
 				dz = iz - cz;
@@ -666,7 +649,7 @@
 		
 		for (var ix = sx; ix <= lx; ++ix)
 		{
-			for (var iz = sz; iz <= lz; ++ iz)
+			for (var iz = sz; iz <= lz; ++iz)
 			{
 				if (fcc)
 					if ((x - ix) > fcc || (ix - x) > fcc || (z - iz) > fcc || (iz - z) > fcc)
@@ -737,7 +720,7 @@
 		
 		for (var ix = sx; ix <= lx; ++ix)
 		{
-			for (var iz = sz; iz <= lz; ++ iz)
+			for (var iz = sz; iz <= lz; ++iz)
 			{
 				dx = ix - cx;
 				dz = iz - cz;
